/*
 * Copyright (c) Michael Thomas, All Rights Reserved. (michael@michael-thomas.com) 
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Exceptions must be in writing between the 
 * copyright holder and entity using the content.
 *
 * THE COPYRIGHT HOLDER MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. THE COPYRIGHT HOLDER SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

/**
 * @author  Michael Thomas
 * @version 1.0 07/04/08
 */

package firststeps;

import java.util.Date;

public class ThreadsHelloWorldSynchronizedSimple_Underconstruction {

	private int intNotSyncExample;
	private int intSyncExample;

	public int getIntNotSyncExample() {
		return intNotSyncExample;
	}

	public void setIntNotSyncExample(int intSyncExample) {
		this.intNotSyncExample = intSyncExample;
	}

	public synchronized int getIntSyncExample() {
		return intSyncExample;
	}

	public synchronized void setIntSyncExample(int intSyncExample) {
		this.intSyncExample = intSyncExample;
	}

	
    private static class ThreadsSyncExample implements Runnable {
    	ThreadsHelloWorldSynchronizedSimple_Underconstruction objHWParent;
    	
    	public ThreadsSyncExample ( ThreadsHelloWorldSynchronizedSimple_Underconstruction objHW ) {
    		objHWParent = objHW;
    	}

    	public void run() {
        	//The Thread's run() method.
            int intLoopCount = 5;
            int intLoopCountCrunch = 1000000;
            String strThreadName = Thread.currentThread().getName();
            System.out.println(strThreadName + " - Start Time - " + (new Date()).toString());

            
           	for (int i = 1; i <= intLoopCount; i++) {
           		
           		for (int x = 1; x <= intLoopCountCrunch; x++) {
           			
                    objHWParent.setIntNotSyncExample( objHWParent.getIntNotSyncExample() + 1 );
                    objHWParent.setIntSyncExample( objHWParent.getIntSyncExample() + 1 );                
           			
           		}

           		System.out.println( strThreadName + " - Hello World #" + i + 
           				            " - Not Sync = " + objHWParent.getIntNotSyncExample() +
           				            " - Sync = " + objHWParent.getIntSyncExample() +
           				            " - " + (new Date()).toString());
   	            
           	}

            System.out.println(strThreadName + " - Stop Time - " + (new Date()).toString());

        }
    }

    public static void main(String args[]) throws InterruptedException {
    	
    	//setIntNotSyncExample( getIntNotSyncExample()++ );
    	String strThreadName = Thread.currentThread().getName();
    	
    	System.out.println(strThreadName + " - Begin - " + (new Date()).toString());

    	ThreadsHelloWorldSynchronizedSimple_Underconstruction objHW = new ThreadsHelloWorldSynchronizedSimple_Underconstruction(); 
    	
    	ThreadsSyncExample objRunnable1 = new ThreadsSyncExample( objHW );
    	Thread objThreadHW1 = new Thread(objRunnable1, "ThreadHW1");

    	ThreadsSyncExample objRunnable2 = new ThreadsSyncExample( objHW );
    	Thread objThreadHW2 = new Thread(objRunnable2, "ThreadHW2");

    	objThreadHW1.start();
    	objThreadHW2.start();

    	System.out.println(strThreadName + " - Finished - " + (new Date()).toString());
    
    }

}
